package com.adventurer_engine.util;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import bx;
import by;
import cd;
import cg;
import ch;
import cj;
import cl;
import com.google.gson.Gson;
import com.google.gson.internal.StringMap;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

public class JsonHelper {
  private static final Gson JSON_PARSER = new Gson();
  
  private InputStreamReader in;
  
  private StringMap root;
  
  public JsonHelper(InputStreamReader in) {
    this.root = JSON_PARSER.<StringMap>fromJson(in, StringMap.class);
    this.in = in;
  }
  
  public JsonHelper(StringMap root) {
    this.root = root;
  }
  
  public JsonHelper(File f) {
    try {
      FileInputStream in = new FileInputStream(f);
      this.root = JSON_PARSER.<StringMap>fromJson(new InputStreamReader(in), StringMap.class);
    } catch (FileNotFoundException e) {
      throw new RuntimeException(e);
    } 
  }
  
  public JsonHelper(InputStream in) {
    this.root = JSON_PARSER.<StringMap>fromJson(new InputStreamReader(in), StringMap.class);
  }
  
  public boolean hasKey(String key) {
    return this.root.containsKey(key);
  }
  
  public boolean getBoolean(String key) {
    return ((Boolean)this.root.get(key)).booleanValue();
  }
  
  public byte getByte(String key) {
    Object tmp = this.root.get(key);
    if (tmp instanceof String) {
      assert ((String)tmp).endsWith("b");
      return Byte.parseByte(((String)tmp).substring(0, ((String)tmp).length() - 1));
    } 
    return ((Double)tmp).byteValue();
  }
  
  public short getShort(String key) {
    Object tmp = this.root.get(key);
    if (tmp instanceof String) {
      assert ((String)tmp).endsWith("s");
      return Short.parseShort(((String)tmp).substring(0, ((String)tmp).length() - 1));
    } 
    return ((Double)tmp).shortValue();
  }
  
  public int getInt(String key) {
    Object tmp = this.root.get(key);
    if (tmp instanceof String)
      return Integer.parseInt((String)this.root.get(key)); 
    return ((Double)tmp).intValue();
  }
  
  public long getLong(String key) {
    Object tmp = this.root.get(key);
    if (tmp instanceof String) {
      assert ((String)tmp).endsWith("l");
      return Long.parseLong(((String)tmp).substring(0, ((String)tmp).length() - 1));
    } 
    return ((Double)tmp).longValue();
  }
  
  public float getFloat(String key) {
    Object tmp = this.root.get(key);
    if (tmp instanceof String) {
      assert ((String)tmp).endsWith("f");
      return Float.parseFloat(((String)tmp).substring(0, ((String)tmp).length() - 1));
    } 
    return ((Double)tmp).floatValue();
  }
  
  public double getDouble(String key) {
    Object o = this.root.get(key);
    if (o instanceof Double)
      return ((Double)o).doubleValue(); 
    if (o instanceof String)
      try {
        return Double.parseDouble((String)o);
      } catch (Exception e) {
        return 0.0D;
      }  
    return 0.0D;
  }
  
  public String getString(String key) {
    return (String)this.root.get(key);
  }
  
  public List getList(String key) {
    return (List)this.root.get(key);
  }
  
  public List<com.adventurer_engine.util.JsonHelper> getJsonList(String key) {
    List ls = getList(key);
    List<com.adventurer_engine.util.JsonHelper> ret = new LinkedList<com.adventurer_engine.util.JsonHelper>();
    for (Object o : ls) {
      if (o instanceof StringMap)
        ret.add(new com.adventurer_engine.util.JsonHelper((StringMap)o)); 
    } 
    return ret;
  }
  
  public int[] getIntArray(String key) {
    List ls = getList(key);
    List<Integer> arr = new LinkedList<Integer>();
    for (Object item : ls) {
      if (item instanceof Number)
        arr.add(Integer.valueOf(((Number)item).intValue())); 
    } 
    int[] ret = new int[arr.size()];
    for (int i = 0; i < ret.length; i++)
      ret[i] = ((Integer)arr.get(i)).intValue(); 
    return ret;
  }
  
  public double[] getDoubleArray(String key) {
    List ls = getList(key);
    List<Double> arr = new LinkedList<Double>();
    for (Object item : ls) {
      if (item instanceof Number)
        arr.add((Double)item); 
    } 
    double[] ret = new double[arr.size()];
    for (int i = 0; i < ret.length; i++)
      ret[i] = ((Double)arr.get(i)).doubleValue(); 
    return ret;
  }
  
  public List<String> getStringArray(String key) {
    List ls = getList(key);
    List<String> arr = new LinkedList<String>();
    for (Object item : ls) {
      if (item instanceof String)
        arr.add((String)item); 
    } 
    return arr;
  }
  
  public com.adventurer_engine.util.JsonHelper getSubJson(String key) {
    StringMap map = (StringMap)this.root.get(key);
    return (map == null) ? null : new com.adventurer_engine.util.JsonHelper(map);
  }
  
  public Set<String> getKeySet() {
    return this.root.keySet();
  }
  
  public by toNBT() {
    by nbt = new by("");
    for (String key : this.root.keySet()) {
      Object value = this.root.get(key);
      if (value instanceof String) {
        String str = (String)value;
        if (str.endsWith("b")) {
          nbt.a(key, Byte.parseByte(str.substring(0, str.length() - 1)));
          continue;
        } 
        if (str.endsWith("s")) {
          nbt.a(key, Short.parseShort(str.substring(0, str.length() - 1)));
          continue;
        } 
        if (str.endsWith("l")) {
          nbt.a(key, Long.parseLong(str.substring(0, str.length() - 1)));
          continue;
        } 
        if (str.endsWith("f")) {
          nbt.a(key, Float.parseFloat(str.substring(0, str.length() - 1)));
          continue;
        } 
        try {
          int i = Integer.parseInt(str);
          nbt.a(key, i);
        } catch (Exception e) {
          nbt.a(key, str);
        } 
        continue;
      } 
      if (value instanceof Double) {
        nbt.a(key, ((Double)value).doubleValue());
        continue;
      } 
      if (value instanceof List) {
        List ls = (List)value;
        if (ls.size() > 0) {
          if (ls.get(0) instanceof Double) {
            int[] arr = new int[ls.size()];
            for (int i = 0; i < arr.length; i++)
              arr[i] = ((Double)ls.get(i)).intValue(); 
            nbt.a(key, arr);
            continue;
          } 
          cg list = new cg(key);
          if (ls.get(0) instanceof String) {
            for (Object o : ls) {
              String str = (String)o;
              if (str.endsWith("b")) {
                list.a((cl)new bx("", Byte.parseByte(str.substring(0, str.length() - 1))));
                continue;
              } 
              if (str.endsWith("s")) {
                list.a((cl)new cj("", Short.parseShort(str.substring(0, str.length() - 1))));
                continue;
              } 
              if (str.endsWith("l")) {
                list.a((cl)new ch("", Long.parseLong(str.substring(0, str.length() - 1))));
                continue;
              } 
              if (str.endsWith("f"))
                list.a((cl)new cd("", Float.parseFloat(str.substring(0, str.length() - 1)))); 
            } 
          } else if (ls.get(0) instanceof StringMap) {
            for (Object o : ls)
              list.a((cl)(new com.adventurer_engine.util.JsonHelper((StringMap)o)).toNBT()); 
          } 
          nbt.a(key, (cl)list);
        } 
        continue;
      } 
      if (value instanceof StringMap)
        nbt.a(key, (cl)(new com.adventurer_engine.util.JsonHelper((StringMap)value)).toNBT()); 
    } 
    return nbt;
  }
  
  public void close() {
    try {
      this.in.close();
    } catch (IOException e) {
      throw new RuntimeException(e);
    } 
  }
}
